//
// Source code recreated from a .class file by IntelliJ IDEA
// (powered by Fernflower decompiler)
//

package br.com.rybena.tts.api;

import br.com.rybena.tts.api.TTSClient.TTSType;
import br.com.rybena.tts.api.exception.ErrorType;
import br.com.rybena.tts.api.exception.ExceptionsError;
import br.com.rybena.tts.api.exception.TTSException;

import java.io.*;
import java.net.HttpURLConnection;
import java.net.URL;
import java.nio.charset.StandardCharsets;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.Arrays;
import java.util.Base64;
import java.util.Collection;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.stream.Collectors;

import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioInputStream;

public class OnlineTTSClient implements TTSClient {
    public static final int ACCESS_KEY = 717346784;
    protected static final String SERVICE_URL_MP3 = "http://tts.rybena.com.br/RybenaServerTTS/TTSApplication/convertmp3/%s/%d";
    protected static final String SERVICE_URL_WAV = "http://tts.rybena.com.br/RybenaServerTTS/TTSApplication/convertwav/%s/%d";
    protected static final AudioFormat DEFAULT_AUDIO_FORMAT = new AudioFormat(22050.0F, 16, 1, true, false);
    protected static final int CON_TIME_OUT = 10000;

    public OnlineTTSClient() {
    }

    public TTSType getType() {
        return TTSType.ONLINE;
    }
    
	private String textCorrectionToCents(String text) {
		
		//System.out.println("textCorrectionToCents INPUT ["+text+"]");
		
	
		final String[] valuesToChange  = {"R$", "$", "EUR"};
		
		for (String valueToChange : valuesToChange) {
		
			valueToChange += "0,";
			final int offset = valueToChange.length();
			int begin, end = 0;
			
			String firstPart = "", secondPart = "", value;
			
			while(text.indexOf(valueToChange) != -1){
				begin = text.indexOf(valueToChange);
				end = text.indexOf(" ", begin + offset);
				
				if(end == -1) {
					end = text.length();
				}				
				
				firstPart = text.substring(0, begin); 
				secondPart = text.substring(end);
				value = text.substring(begin + offset, end);

				text = firstPart + value + " centavos" + secondPart;
			}
		}
			
		//System.out.println("textCorrectionToCents OUTPUT ["+text+"]");
		return text;	
		
}

    public AudioInputStream speak(String text) throws Throwable {
        AudioInputStream ret = null;
        text = textCorrectionToCents(text);
        String b64text = Base64.getEncoder().encodeToString(text.getBytes(StandardCharsets.UTF_8));
        String callUrl = String.format(SERVICE_URL_WAV, b64text, ACCESS_KEY);

        try {
            DateTimeFormatter dtf = DateTimeFormatter.ofPattern("yyyy/MM/dd HH:mm:ss");
            LocalDateTime now = LocalDateTime.now();

            File file = new File("log.txt");
            if(!file.exists()){
                file.createNewFile();
            }

//            FileWriter fw = new FileWriter(file,true);

            Writer fw = new OutputStreamWriter(new FileOutputStream(file, true), StandardCharsets.UTF_8);


            BufferedWriter bw = new BufferedWriter(fw);
            PrintWriter pw = new PrintWriter(bw);
            pw.println("[" + dtf.format(now) + "] Text: " + text + " / B64: " + b64text);
            pw.close();

            Throwable var5 = null;
            Object var6 = null;

            try {
                ByteArrayOutputStream outputStream = new ByteArrayOutputStream();

                try {
                    URL url = new URL(callUrl);
                    HttpURLConnection httpConn = (HttpURLConnection)url.openConnection();
                    httpConn.setConnectTimeout(CON_TIME_OUT);
                    int responseCode = httpConn.getResponseCode();
                    if (responseCode != 200) {
                        throw new TTSException(ErrorType.INTEGRATION_ERROR, ExceptionsError.REMOTE_SERVER_ERROR);
                    } else {
                        String fileName = "";
                        String disposition = httpConn.getHeaderField("Content-Disposition");
                        String contentType = httpConn.getContentType();
                        int contentLength = httpConn.getContentLength();
                        InputStream inputStream = httpConn.getInputStream();
                        int bytesRead = 0;

                        int buffer;
                        for(boolean var17 = true; (buffer = inputStream.read()) != -1; ++bytesRead) {
                            if (bytesRead > 49) {
                                outputStream.write(buffer);
                            }
                        }

                        byte[] audioRaw = outputStream.toByteArray();
                        ret = new AudioInputStream(new ByteArrayInputStream(audioRaw), DEFAULT_AUDIO_FORMAT, (long)(audioRaw.length / 2));
                        inputStream.close();
                        httpConn.disconnect();
                        return ret;
                    }
                } finally {
                    if (outputStream != null) {
                        outputStream.close();
                    }

                }
            } catch (Throwable var26) {
                if (var5 == null) {
                    var5 = var26;
                } else if (var5 != var26) {
                    var5.addSuppressed(var26);
                }

                throw var5;
            }
        } catch (IOException var27) {
            var27.printStackTrace();
            throw new TTSException(ErrorType.INTEGRATION_ERROR, var27);
        }
    }
}
