//
// Source code recreated from a .class file by IntelliJ IDEA
// (powered by Fernflower decompiler)
//

package br.com.rybena.tts.api;

import br.com.rybena.tts.api.exception.ErrorType;
import br.com.rybena.tts.api.exception.ExceptionsError;
import br.com.rybena.tts.api.exception.TTSException;
import javax.sound.sampled.AudioInputStream;

public interface TTSClient {
    String DEFAULT_TTS_CLASS_NAME = "br.com.rybena.tts.api.OnlineTTSClient";
    String DEFAULT_TTS_PROPERTY = "DEFAULT_TTS_CLASS_NAME";

    TTSClient.TTSType getType();

    AudioInputStream speak(String var1) throws Throwable;

    static TTSClient newDefaultClient() throws TTSException {
        TTSClient ret = null;

        try {
            Class<?> ttsC = Class.forName(System.getProperty("DEFAULT_TTS_CLASS_NAME", "br.com.rybena.tts.api.OnlineTTSClient"));
            if (ttsC.isAssignableFrom(TTSClient.class)) {
                throw new TTSException(ErrorType.INTERNAL_ERROR, ExceptionsError.IMPLEMENTATION_NOT_FOUND);
            } else {
                ret = (TTSClient)ttsC.newInstance();
                return ret;
            }
        } catch (IllegalAccessException | ClassNotFoundException | InstantiationException var2) {
            throw new TTSException(ErrorType.INTERNAL_ERROR, var2);
        }
    }

    public static enum TTSType {
        ONLINE,
        OFFLINE,
        OFFLINE_LINUX,
        OFFLINE_WINDOWS;

        private TTSType() {
        }
    }
}
