//
// Source code recreated from a .class file by IntelliJ IDEA
// (powered by Fernflower decompiler)
//

package br.com.rybena.tts.api.exception;

import br.com.rybena.tts.api.exception.errors_msg.ErrorMenssagesProvider;
import java.net.UnknownHostException;

public class TTSException extends Exception {
    private static final long serialVersionUID = -6121454348554065138L;
    protected static final String TO_STRING_FMT = "%s(COD:%d - %s)";
    protected static final ErrorMenssagesProvider EMP = new ErrorMenssagesProvider();
    protected final String userMessage;
    protected final long errorCode;
    protected final ErrorType errorType;
    protected final ExceptionsError error;

    public TTSException(ErrorType te, ExceptionsError e) {
        this(te, e, (Throwable)null, (String)null);
    }

    public TTSException(ErrorType te, Throwable cause) {
        this(te, getErroFromException(cause), cause, cause.getMessage());
    }

    public TTSException(ErrorType te, ExceptionsError e, Throwable cause, String msg) {
        super(msg == null ? EMP.getMessage(te, e) : msg, cause);
        this.userMessage = EMP.getMessage(te, e);
        this.errorCode = (long)(te.ordinal() & e.ordinal() >> 16);
        this.errorType = te;
        this.error = e;
    }

    public String getUserMessage() {
        return this.userMessage;
    }

    public long getErrorCode() {
        return this.errorCode;
    }

    public String toString() {
        return String.format("%s(COD:%d - %s)", this.userMessage, this.errorCode, this.getMessage());
    }

    public static ExceptionsError getErroFromException(Throwable cause) {
        Throwable localCuase = cause;
        ExceptionsError e = null;

        String messageRoot;
        for(messageRoot = cause.getMessage(); (localCuase = localCuase.getCause()) != null; messageRoot = localCuase.getMessage()) {
        }

        System.out.println(cause.getClass().getName());
        if (cause instanceof UnknownHostException) {
            e = ExceptionsError.NO_INTERNET_ACCESS;
        } else if (messageRoot != null) {
            if (messageRoot.contains("duplicate key")) {
                e = ExceptionsError.RESOURCE_DUPLICATED;
            } else if (messageRoot.contains("violates not-null constraint")) {
                e = ExceptionsError.INVALID_PARAMETER;
            } else {
                e = ExceptionsError.UNKNOWN_ERROR;
            }
        } else {
            e = ExceptionsError.UNKNOWN_ERROR;
        }

        return e;
    }
}
